#version 330
// From vertex shader
in vec2 texcoord;
in vec3 position;

// Application data
uniform sampler2D sampler0;
uniform vec3 fcolor;
uniform vec2 screen_size;
uniform vec3 light[20];
uniform int count;

// Output color
layout(location = 0) out  vec4 color;

void main()
{
	float dx, dy;
	float diffuse = 1;
	for (int i = 0; i < count; i++) {
		dx = (abs(position.x - light[i].x) / screen_size.x);
		dy = (abs(position.y - light[i].y) / screen_size.y);
		diffuse *= min(sqrt(dx*dx+dy*dy) * light[i].z, 1);
	}
	color = vec4(fcolor, diffuse) * texture(sampler0, vec2(texcoord.x, texcoord.y));
}
