#version 330
// From vertex shader
in vec2 texcoord;
in vec3 position;

// Application data
uniform sampler2D sampler0;
uniform vec3 fcolor;
uniform vec2 room_bound;
uniform vec2 offset;
uniform vec2 screen_size;

// Output color
layout(location = 0) out  vec4 color;

void main()
{
	float dx, dy;
	float diffuse = 0;
	dx = position.x + (offset.x / screen_size.x) * position.x;// - screen_size.x * 0.02; // fragment coord + (scaled / offset) room bound + fade away
	dy = position.y + (offset.y / screen_size.y) * position.y;// - screen_size.y * 0.02;
	if (dx > room_bound.x + (offset.x / screen_size.x) * position.x || dx < 0 || dy > room_bound.y + (offset.y / screen_size.y) * position.y || dy < 0) {
		//float fade_factor_x = min(abs(dx - room_bound.x), abs(-dx));
		//float fade_factor_y = min(abs(dy - room_bound.y), abs(-dy));
		//diffuse = max(log2(min(fade_factor_x, fade_factor_y)) - 4, 0);
		diffuse = 1;
	}
	color = vec4(fcolor, diffuse) * texture(sampler0, vec2(texcoord.x, texcoord.y));
}
